<script setup lang="ts">
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import SMessageForm from '../../components/messages/SMessageForm.vue'
    import { ref, watch } from 'vue'
    import { useRouter } from 'vue-router'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { MessageApi } from '../../entities/messages/MessageApi'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { Message } from '../../entities/messages/Message'
    import { messageMapper } from '../../entities/messages/MessageMapper'
    import { useBreadcrumb } from '@/shared/routing/composables/breadCrumb'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    const router = useRouter()
    const { getParentRoute } = useBreadcrumb()

    const msal = useMsal()
    const userStore = useUserStore(msal)

    const messageApi = new MessageApi(msal)

    const messageId = Number(router.currentRoute.value.params.id)

    const message = ref<Message | undefined>()

    const isLoading = ref(false)

    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            isLoading.value = true
            messageApi
                .get(messageId)
                .then(async (fetchedMessage) => {
                    message.value = fetchedMessage
                })
                .catch((error) => {
                    emitSnackBar((<Error>error).message, 'error')
                    router.push(getParentRoute())
                })
                .finally(() => (isLoading.value = false))
        },
        { immediate: true }
    )

    async function updateMessage() {
        if (message.value) {
            try {
                const messageDto = messageMapper.toEditDto(message.value)
                await messageApi.update(messageId, messageDto)

                emitSnackBar(`Message modifié`, 'primary')
                router.push(getParentRoute())
            } catch (error) {
                emitSnackBar((<Error>error).message, 'error')
                router.push(getParentRoute())
            }
        }
    }
</script>

<template>
    <s-contextual-navbar page-title="Modifier un message"></s-contextual-navbar>
    <v-main>
        <s-content-container>
            <v-skeleton-loader
                v-if="isLoading"
                type="heading, heading, heading, actions"
            ></v-skeleton-loader>
            <s-message-form
                v-if="message"
                v-model="message"
                :loading="messageApi.isProcessing.value"
                @submit.prevent="updateMessage()"
            >
            </s-message-form>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
